#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR DATA FILES  

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use psfp;
use Time::Local; 
use obbuild;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################

print "Content-type: text/html\n\n";

if ($q->param('fct') eq "") { &start; }
if ($q->param('fct') eq "edit_filter") { &edit_filter; }

if ($q->param('fct') eq "add_email") { &add_filter; }
if ($q->param('fct') eq "add_keywords") { &add_filter; }
if ($q->param('fct') eq "add_domain") { &add_filter; }
if ($q->param('fct') eq "add_ip") { &add_filter; }

if ($q->param('fct') eq "delete_items") { &delete_items; }
if ($q->param('fct') eq "set_per_page") { &set_per_page; }

if ($q->param('fct') eq "viewblocked") { &viewblocked; }
if ($q->param('fct') eq "clear") { &clear_log; }





sub clear_log
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

	$sql = "DELETE FROM blocklog";
	$sth = $dbh->prepare($sql);
	$sth->execute; 
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 	

$sth->finish;
$dbh->disconnect;

$hbox = acs::get_heading_box("$web_url/ic_spam.gif", "Block Log Cleared", qq[
<a href="$admin_url/admin60.cgi">Click Here to Continue</a>
]);



print qq[
<html>

<head>
<title>Spam Filter</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>

$hbox

</body>
</html>
];

}






sub viewblocked
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

	$sql = "SELECT * FROM blocklog ORDER BY add_date DESC";
	$sth = $dbh->prepare($sql);
	$sth->execute; 
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 	
	$rows = $sth->rows(); 


### PREPARE PAGES
$icnt = $rows;
$nr_searchres = 50;

$modp = ($icnt % $nr_searchres);
$pages = ($icnt - $modp) / $nr_searchres;
if ($modp != 0) {$pages++;}

$st = $q->param('st');
$nd = $q->param('nd');
if ($st eq ""){$st = 0;}
if ($nd eq ""){$nd = $nr_searchres;}
$ippc = 1; 
$cc = 0;



	while ( @row = $sth->fetchrow() )
		{
		if (($ippc > $st) and ($ippc <= $nd)) 
			{		
			$toprint = $toprint . qq[<a href="$row[4]" target="_blank"><b>$row[1]</b></a><BR>
			$row[2]<BR>
			<b>Keywords:</b> $row[3]<BR>
			<a href="$row[4]" target="_blank"><b>$row[4]</b></a><BR>
			Email: $row[5]<BR>
			Name: $row[6]<BR>
			Date: $row[7]<BR>
			IP: $row[8]<BR>
			<font color="#FF8080">Reason: $row[9]</font><BR><BR>
			];
			}
		$ippc++;
		}

$sth->finish;
$dbh->disconnect;


#### PAGES 

for ($ms = 0; $ms < $pages; $ms++) 
	{
	$pg = $ms + 1;
	if ($nd == ($pg * $nr_searchres))
		{
		$pgstring = $pgstring . " [$pg] ";
		$targpage = $pg;
		}
	  	else
		{
		$st1 = ($pg * $nr_searchres) - $nr_searchres;
		$nd1 = ($pg * $nr_searchres);
		$pgstring = $pgstring . "<a href=\"$admin_url/admin60.cgi?st=$st1&nd=$nd1&fct=viewblocked\">$pg</a> ";
		}
	}

if ($pages > 1)
	{
	$pgstring = "Pages: " . $pgstring;
	}
	else
	{
	$pgstring = "";
	}

$page_crit = $page_crit .  $pgstring . "<BR><BR>";


if ($rows > 0)
	{
	$rtext = qq[The spam filter has blocked these listings from being submitted.<BR>];
	$hlines = qq[<hr noshade size="1" color="#EBEBEB">];
	}


$hbox = acs::get_heading_box("$web_url/ic_spam.gif", "View Block Log", qq[
$rtext <b>$rows Submissions Has Been Blocked </b><br> <a href="$admin_url/admin60.cgi">Go Back to Spam Filter Main </a>
]);


print qq[

<html>
<head>
<title>Spam Filter</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>

$hbox

<p>$pgstring</p>

$hlines

<p>
<blockquote>
$toprint

</blockquote>
</p>
$hlines

<p>$pgstring</p><BR><BR>
</body></html>
];


}





sub set_per_page
{

$results = $q->param('results');

open (CA, "> $data_dir/spampgs.dat");
	print CA $results;
close (CA);

&edit_filter;

}






sub delete_items
{

$filter = $q->param('filter');
$totalsel = $q->param('totalsel');

for ($ms = 0; $ms < $totalsel; $ms++) 
	{
	$selname = "C" . $ms;
	$itemvalue = $q->param($selname);
	
	if ($itemvalue ne "") { $where_sql = $where_sql . " (spid = '$itemvalue') OR"; }
	}

$where_sql = substr($where_sql, 0, length($where_sql) - 2);

if ($where_sql eq "") {acs::problem_popup("You have to select something."); }

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

	$sql = "DELETE FROM spamfilter WHERE $where_sql";
	$sth = $dbh->prepare($sql);
	$sth->execute; 
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 	

$sth->finish;
$dbh->disconnect;



$hbox = acs::get_heading_box("$web_url/ic_spam2.gif", "Filter(s) Deleted", qq[
<a href="$admin_url/admin60.cgi?fct=edit_filter&amp;filter=$filter">Click Here to Continue</a>
]);


print qq[

<html>
<head>
<title>Spam Filter</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>

$hbox
</body>
</html>

];

}






sub add_filter
{

$filtername = $q->param('filtername');

@allines = split (/\n/, $filtername);

$crit1 = chr(10); $crit2 = chr(13);

	my %seen = (); 
	foreach $item (@allines)
		{
		$item =~ s/\n//gi; $item =~ s/$crit1//gi; $item =~ s/$crit2//gi;
		push(@uniq, $item) unless $seen{$item}++; 
		} 


if ($filtername eq "")
	{
	acs::problem_popup("You have to supply some text to add a filter.");  
	}


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 


if ($q->param('fct') eq "add_email") 
	{
	$typefilter = "E"; $fpass = "email"; 
	$pw = $q->param('partwhole');
	$partial_or_whole = ", matchtype = '$pw'";
	}

if ($q->param('fct') eq "add_keywords") 
	{
	$typefilter = "K"; $fpass = "keyw"; 
	$pw = $q->param('partwhole');
	$partial_or_whole = ", matchtype = '$pw'";
	}


if ($q->param('fct') eq "add_domain") 
	{
	$typefilter = "D"; $fpass = "domain"; 
	}


if ($q->param('fct') eq "add_ip") 
	{
	$typefilter = "I"; $fpass = "ip"; 
	}




$dupl = 0;

foreach $fitem (@uniq)
	{
	if ($fitem ne "")
		{
		$fitem = acs::remove_leading_spacing($fitem);
		$fitem =~ s/'/\\'/g; 
		$sql = "INSERT INTO spamfilter SET criteria = '$fitem', typefilter = '$typefilter' $partial_or_whole";
		
		eval 
		{
		$sth = $dbh->prepare($sql);
		$sth->execute; 
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 	
		};
		
			if ($@ ne "")
				{
				$dupl++;
				$@ = "";
				}
		}
	}




$sth->finish;
$dbh->disconnect;


if ($dupl > 0)
	{
	$duptext = "Found $dupl duplicates. These were not added.<BR>";
	}


$hbox = acs::get_heading_box("$web_url/ic_spam2.gif", "Filter(s) Added", qq[
$duptext
<a href="$admin_url/admin60.cgi?fct=edit_filter&amp;filter=$fpass">Click Here to Continue</a>
]);

print qq[

<html>
<head>
<title>Spam Filter</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
</body>
</html>

];



}













sub edit_filter
{
$filter = $q->param('filter');

if ($filter eq "email") 
{
$filter_edit = "Email Filter"; 
$typefilter = "E"; 
$supply_text = "Supply Email Addresses Below";
$typeword = "Email Addresses";
$diztext = "If any email addresses in this filter is found in a new submission then it will not be accepted.";
$filterpass = "add_email";
}



if ($filter eq "keyw") 
{
$filter_edit = "Keyword Filter"; 
$typefilter = "K"; 
$supply_text = "Supply Keywords Below";
$diztext = "If any keywords in this filter is found in a new submission then the new submission will not be accepted.";
$typeword = "Keywords";
$filterpass = "add_keywords";
}



if ($filter eq "domain") 
{
$filter_edit = "Domain Name Filter"; 
$typefilter = "D"; 
$supply_text = "Supply Domain Names Below";
$typeword = "Domain Names";
$diztext = "If any domain names in this filter is found in a URL with a new submission then it will not be accepted.";
$filterpass = "add_domain";
}

if ($filter eq "ip") 
{
$filter_edit = "IP Address Filter"; 
$typefilter = "I"; 
$supply_text = "Supply IP Addresses Below";
$typeword = "IP Adresses";
$diztext = "Submissions will not be accepted when the submitters IP address is present within this filter.";
$filterpass = "add_ip";
}




$hbox = acs::get_heading_box("$web_url/ic_spam2.gif", "Edit $filter_edit", qq[
$diztext<br>
<b><a href="$admin_url/admin60.cgi">Go Back to Spam Filter Main</a></b>
]);



print qq[
<html>
<head>
<title>Spam Filter</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>

<body>

$hbox

];





if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

$wsql = "SELECT * FROM spamfilter WHERE typefilter = '$typefilter'";
$sth = $dbh->prepare($wsql);
$sth->execute; 
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 	
$rows = $sth->rows(); 

### PREPARE PAGES
$icnt = $rows;

$nr_searchres = acs::get_file_contents("$data_dir/spampgs.dat");  
if ($nr_searchres < 1) { $nr_searchres = 50; }


$modp = ($icnt % $nr_searchres);
$pages = ($icnt - $modp) / $nr_searchres;
if ($modp != 0) {$pages++;}

$st = $q->param('st');
$nd = $q->param('nd');
if ($st eq ""){$st = 0;}
if ($nd eq ""){$nd = $nr_searchres;}
$ippc = 1; 
$cc = 0;


	while ( @row = $sth->fetchrow() )
		{
		if (($ippc > $st) and ($ippc <= $nd)) 
			{
			$cbox = "C" . $cc;
			
			$partwole = "";
			if ($row[3] eq "P") { $partwole = "Partial"; } 
			if ($row[3] eq "W") { $partwole = "Whole"; } 
			
			
			if (($filter ne "ip") and ($filter ne "domain"))
				{
				$criterias = $criterias . qq[  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td width="603" class="normaltext"><input type="checkbox" name="$cbox" value="$row[0]"> $row[1] </td>
    <td width="184" class="normaltext"><p align="center">$partwole </td>
  </tr>];
  
				}
				else
				{
				$criterias = $criterias . "<input type=\"checkbox\" name=\"$cbox\" value=\"$row[0]\"> " . $row[1] . "<BR>";
				}
			
			$selall_crit = $selall_crit . "'C" . $cc . "',"; 
			$cc++;
			}
		$ippc++;
		}

$selall_crit = substr($selall_crit, 0, length($selall_crit) -1 );

$sth->finish;
$dbh->disconnect;



#### PAGES 

for ($ms = 0; $ms < $pages; $ms++) 
	{
	$pg = $ms + 1;
	if ($nd == ($pg * $nr_searchres))
		{
		$pgstring = $pgstring . " [$pg] ";
		$targpage = $pg;
		}
	  	else
		{
		$st1 = ($pg * $nr_searchres) - $nr_searchres;
		$nd1 = ($pg * $nr_searchres);
		$pgstring = $pgstring . "<a href=\"$admin_url/admin60.cgi?st=$st1&nd=$nd1&fct=edit_filter&filter=$filter\">$pg</a> ";
		}
	}

if ($pages > 1)
	{
	$pgstring = "Pages: " . $pgstring;
	}
	else
	{
	$pgstring = "";
	}

if ($pgstring ne "") { $page_crit = $page_crit .  $pgstring . "<BR><BR>"; }




### PREV NEXT PAGES

$spls = $modp;
if ($spls == 0){$spls++;}

 if ($nd <= ($icnt - $spls))
 	{
	$st1 = $st + $nr_searchres;
	$nd1 = $nd + $nr_searchres;
	$nextt = "<a href=\"$admin_url/admin60.cgi?st=$st1&nd=$nd1&fct=edit_filter&filter=$filter\">Next Page >></a> ";
	}

 if ($st > 0)
	 	{
		$st1 = $st - $nr_searchres;
		$nd1 = $nd - $nr_searchres;
		$prev = "<a href=\"$admin_url/admin60.cgi?st=$st1&nd=$nd1&fct=edit_filter&filter=$filter\"><< Prev Page</a> ";
		}

if (($prev ne "") and ($nextt ne ""))
	{
	$spcer = " | ";
	}
	else
	{
	$spcer = " ";
	}
	  
	$prevnext = $prev . "$spcer" . $nextt;

	if (length($prevnext) > 5){$myspacer = " | ";} 




############

	
if (length($prevnext) > 3) {$prevnext = $prevnext . " | "; }

if (($filter ne "ip") and ($filter ne "domain"))
	{
$criterias = qq[

<table border="0" cellpadding="3" cellspacing="1" width="100%"
style="border: 1px solid rgb(219,219,219)">
  <tr>
    <td width="603" height="30" background="$web_url/bar6.gif" bgcolor="#F5F5F5" class="normaltext"><strong>Keywords </strong></td>
    <td width="184" align="center" background="$web_url/bar6.gif" bgcolor="#F5F5F5" class="normaltext"><strong>Match Type </strong></td>
  </tr>
$criterias
</table>

];
	}
	

if ($nr_searchres == 10) { $sel10 = "selected"; }
if ($nr_searchres == 20) { $sel20 = "selected"; }
if ($nr_searchres == 30) { $sel30 = "selected"; }
if ($nr_searchres == 50) { $sel50 = "selected"; }
if ($nr_searchres == 100) { $sel100 = "selected"; }
if ($nr_searchres == 200) { $sel200 = "selected"; }
if ($nr_searchres == 400) { $sel400 = "selected"; }
if ($nr_searchres == 500) { $sel500 = "selected"; }
if ($nr_searchres == 1000) { $sel1000 = "selected"; }
if ($nr_searchres == 5000) { $sel5000 = "selected"; }


if ($rows > 0) 
{
$select_form = qq[
<form method="POST" action="$admin_url/admin60.cgi" name="select_all">
<span class="normaltext">

$prevnext $page_crit

$criterias
<BR>
<input type="submit" value="Delete Checked Items" name="B1">
<BR><BR>
<a href="javascript:checkall('select_all',true)">Check All</a> | 
<a href="javascript:checkall('select_all',false)">UnCheck All</a>
<BR><BR>
Found $rows Filters in Total<BR>
<input type="hidden" name="fct" value="delete_items">
<input type="hidden" name="filter" value="$filter">
<input type="hidden" name="totalsel" value="$cc">
</form>

<BR>
<form method="POST" action="$admin_url/admin60.cgi">
  <input type="hidden" name="fct" value="set_per_page"><input type="hidden" name="filter"
  value="$filter"><table border="0" cellpadding="2" cellspacing="0" width="50">
    <tr>
      <td><font face="Verdana" size="1"><select name="results" size="1">
        <option value="10" $sel10>List 10 Results Per Page</option>
        <option value="20" $sel20>List 20 Results Per Page</option>
        <option value="30" $sel30>List 30 Results Per Page</option>
        <option value="50" $sel50>List 50 Results Per Page</option>
        <option value="100" $sel100>List 100 Results Per Page</option>
        <option value="200" $sel200>List 200 Results Per Page</option>
        <option value="400" $sel400>List 400 Results Per Page</option>
        <option value="500" $sel500>List 500 Results Per Page</option>
        <option value="1000" $sel1000>List 1000 Results Per Page</option>
        <option value="5000" $sel5000>List 5000 Results Per Page</option>
      </select></font></td>
      <td><font face="Verdana" size="1"><input type="submit" value="   Go   " name="B1"></font></td>
    </tr>
  </table>
</form>

];
}
else
{
$select_form = qq[<p>There are no filters available. Please use the fill in box below to add filters.</p>];

}


if (($filter eq "ip") or ($filter eq "domain"))
{
$addform = qq[


<form method="POST" action="$admin_url/admin60.cgi">
  <input type="hidden" name="fct" value="$filterpass"><table border="0" cellpadding="6"
  cellspacing="1" width="100%" bgcolor="#DDDDDD">
    <tr>
      <td width="130%" background="$web_url/bar6.gif"><span class="normaltext"><strong>$supply_text
      (one per line)</strong></span></td>
    </tr>
    <tr>
      <td width="130%" bgcolor="#FFFFFF"><textarea rows="12" name="filtername" cols="62"
      style="width:100%"></textarea><p><strong><font face="Verdana" size="1"><input
      type="submit" value="   Add Items   " name="B1"></font></strong></td>
    </tr>
  </table>

<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>
 
 
</form>




];
}
else
{
$addform = qq[

<form method="POST" action="$admin_url/admin60.cgi">
  <input type="hidden" name="fct" value="$filterpass"><table border="0" cellpadding="4"
  cellspacing="1" width="100%" bgcolor="#DBDBDB">
    <tr>
      <td width="130%" background="$web_url/bar6.gif" class="normaltext"><strong>$supply_text: (one per line) </strong></td>
    </tr>
    <tr>
      <td width="130%" bgcolor="#FFFFFF" class="normaltext"><textarea rows="12" name="filtername" cols="62" style="width:100%">
</textarea> <p>How would you like these $typeword to be matched? <strong><input type="radio"
      value="P" name="partwhole" checked> Partial <input type="radio" value="W" name="partwhole">
      Whole </strong></p>
      <p><strong><input type="submit" value="   Add Items   " name="B1"> </strong></p>
      <p><strong>What is Whole or Partial keyword Matches? </strong></p>
      <blockquote>
        <p><strong>Whole Word Matching: <br>
        </strong>'Whole word matching' matches whole words. For example: <strong>Spam </strong><br>
        This will only match <strong>Spam </strong>and not <strong>Spammed <br>
        &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <br>
        Partial Word Matching: <br>
        </strong>'Partial matching', matches any word in words. Let's say you specified <strong>Spam
        </strong>as a keyword. If <strong>Spammed </strong>was found within a submission, the
        submission would be blocked because <strong>Spammed </strong>contained the word <strong>Spam
        </strong></p>
        <p><strong>Note that the keywords you specify is not case sensitive </strong></p>
      </blockquote>
      </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"></td>
      <td width="99%"></td>
    </tr>
  </table>
</form>	


];

}


	
print qq[

<script LANGUAGE="JavaScript">
<!-- Hide

function checkall(formname,thestate)
	{
	BoxNames=new Array($selall_crit)
	for (c=0;c < BoxNames.length; c++)
		{
		boxname = eval("document." + formname + "." + BoxNames[c])
		boxname.checked = thestate
		}
	}
// -->
</script>

$select_form

$prevnext $page_crit
</span>

<hr noshade size="1" color="#EBEBEB">

$addform

];
	



}






sub start
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

$wsql = "SHOW TABLES";
$sth = $dbh->prepare($wsql);
$sth->execute; 



while ( @row = $sth->fetchrow() )
	{ 
	if ($row[0] eq "spamfilter") { $spamfilter_table_found = "True"; } 
	if ($row[0] eq "blocklog") { $blocklog_table_found = "True"; } 
	}


if ($blocklog_table_found ne "True")
	{
	
	$sql = "CREATE TABLE blocklog
					(
					bid				int NOT NULL auto_increment,
					title				varchar(255),
					description		varchar(255),
					keywords			varchar(255),
					url				varchar(255),
					email				varchar(255),
					contact			varchar(255),
					add_date			date,
					ip					varchar(50),
					reason			text,
					ext1				varchar(255),
					ext2				varchar(255),
					
					PRIMARY KEY(bid)
					)";
							
		$sth = $dbh->prepare($sql);
		$sth->execute;
		#$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 	
	}

if ($spamfilter_table_found ne "True")
	{
	
	$sql = "CREATE TABLE spamfilter
					(
					spid				int NOT NULL auto_increment,
					criteria			varchar(255),
					typefilter		varchar(1),
					matchtype		varchar(1),
					
					PRIMARY KEY(spid),
					UNIQUE (criteria),
					INDEX (criteria),
					INDEX (typefilter)
					)";
							
		$sth = $dbh->prepare($sql);
		$sth->execute;
		#$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 	
	}



## E K D I
	$sql = "SELECT count(*) FROM spamfilter WHERE typefilter = 'E'";
	$sth = $dbh->prepare($sql);
	$sth->execute; 
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 	
	while ( @row = $sth->fetchrow() ) { $email_count = $row[0]; }

	$sql = "SELECT count(*) FROM spamfilter WHERE typefilter = 'D'";
	$sth = $dbh->prepare($sql);
	$sth->execute; 
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 	
	while ( @row = $sth->fetchrow() ) { $domain_count = $row[0]; }

	$sql = "SELECT count(*) FROM spamfilter WHERE typefilter = 'K'";
	$sth = $dbh->prepare($sql);
	$sth->execute; 
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 	
	while ( @row = $sth->fetchrow() ) { $keyword_count = $row[0]; }

	$sql = "SELECT count(*) FROM spamfilter WHERE typefilter = 'I'";
	$sth = $dbh->prepare($sql);
	$sth->execute; 
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 	
	while ( @row = $sth->fetchrow() ) { $ip_count = $row[0]; }


	$sql = "SELECT count(*) FROM blocklog";
	$sth = $dbh->prepare($sql);
	$sth->execute; 
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 	
	while ( @row = $sth->fetchrow() ) { $block_count = $row[0]; }


$sth->finish;
$dbh->disconnect;



$hbox = acs::get_heading_box("$web_url/ic_spam2.gif", "Spam Filter", qq[

<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <td width="84%" valign="top" class="normaltext">The Spam/Keyword filter enables you to block submissions
    which you do not want included in your new submissions area for approval. This can be
    useful to completely ignore spam, a spammer, or to keep your directory family friendly.
    Note that once you added keywords here, the submission containing those keywords will be
    blocked completely and the blocked submission will only show in the 'blocked log'. The
    submitter will get the idea he submitted successfully but the submission will have been in
    fact blocked. <strong>Use with caution </strong>as you can block submissions that you
    don't want blocked. <strong>Make sure you understand how this works, before using it. </strong>See
    the online documentation for complete information. </td>
    <td width="7%" align="right" valign="top" class="normaltext"><a href="$admin_url/help.cgi?fct=spam_filter"
    target="_blank"><strong><img src="$web_url/bhelps.gif" border="0"> </strong></a></td>
  </tr>
</table>
]);
 


print qq[

<html>
<head>
<title>Spam Filter</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>

$hbox





<table border="0" cellpadding="4" cellspacing="1" width="100%" bgcolor="#DBDBDB">
  <tr align="center">
    <td width="5%" height="30" background="$web_url/bar6.gif" bgcolor="#FFFFFF" class="normaltext"></td>
    <td width="30%" background="$web_url/bar6.gif" bgcolor="#FFFFFF" class="normaltext"><p align="left"><strong>Filters (Click to
    Edit) </strong></td>
    <td width="98%" background="$web_url/bar6.gif" bgcolor="#FFFFFF" class="normaltext"><p align="left"><strong>Filter Description </strong></td>
  </tr>
  <tr>
    <td width="1%" height="60" align="center" bgcolor="#FFFFFF" class="normaltext"><strong><img
    src="$web_url/ic_spam3.gif"> </strong></td>
    <td width="11%" height="60" bgcolor="#FFFFFF" class="normaltext"><strong>&nbsp;&nbsp;&nbsp; <a
    href="$admin_url/admin60.cgi?fct=edit_filter&amp;filter=keyw">Keyword Filter </a></strong>($keyword_count)    </td>
    <td width="118%" height="60" bgcolor="#FFFFFF" class="normaltext">If keywords match inside the title,
    description or keywords of a submission then the submission won't be accepted. This can
    also be used to accept only family friendly submissions by excluding listings that contain
    offensive words. </td>
  </tr>
  <tr>
    <td width="1%" height="60" align="center" bgcolor="#FFFFFF" class="normaltext"><strong><img
    src="$web_url/ic_email4.gif"> </strong></td>
    <td width="11%" height="60" bgcolor="#FFFFFF" class="normaltext"><strong>&nbsp;&nbsp;&nbsp; <a
    href="$admin_url/admin60.cgi?fct=edit_filter&amp;filter=email">Email Filter </a></strong>($email_count)    </td>
    <td width="118%" height="60" bgcolor="#FFFFFF" class="normaltext">If any email addresses in this filter is
    found in a new submission then the new submission will not be accepted. </td>
  </tr>
  <tr>
    <td width="1%" height="60" align="center" bgcolor="#FFFFFF" class="normaltext"><strong><img
    src="$web_url/ic_planet.gif"> </strong></td>
    <td width="11%" height="60" bgcolor="#FFFFFF" class="normaltext"><strong>&nbsp;&nbsp;&nbsp; <a
    href="$admin_url/admin60.cgi?fct=edit_filter&amp;filter=domain">Domain Name Filter </a></strong>($domain_count)    </td>
    <td width="118%" height="60" bgcolor="#FFFFFF" class="normaltext">If any domain names inside this filter is
    found in a new submission then the new submission will not be accepted. </td>
  </tr>
  <tr>
    <td width="1%" height="60" align="center" bgcolor="#FFFFFF" class="normaltext"><strong><img
    src="$web_url/ic_lock.gif"> </strong></td>
    <td width="11%" height="60" bgcolor="#FFFFFF" class="normaltext"><strong>&nbsp;&nbsp;&nbsp; <a
    href="$admin_url/admin60.cgi?fct=edit_filter&amp;filter=ip">IP Filter </a></strong>($ip_count)    </td>
    <td width="118%" height="60" bgcolor="#FFFFFF" class="normaltext">Submissions will not be accepted when the
    submitters IP address is present within this filter. </td>
  </tr>
  <tr>
    <td width="6%" height="30" background="$web_url/bar6.gif" bgcolor="#FFFFFF" class="normaltext"></td>
    <td width="29%" background="$web_url/bar6.gif" bgcolor="#FFFFFF" class="normaltext"><p align="left"><strong>Block Log Functions
    </strong></td>
    <td width="98%" background="$web_url/bar6.gif" bgcolor="#FFFFFF" class="normaltext"><p align="left"><strong>Description </strong></td>
  </tr>
  <tr>
    <td width="2%" height="60" align="center" bgcolor="#FFFFFF" class="normaltext"><strong><img
    src="$web_url/ic_spam.gif"> </strong></td>
    <td width="10%" height="60" bgcolor="#FFFFFF" class="normaltext"><strong>&nbsp;&nbsp;&nbsp; <a
    href="$admin_url/admin60.cgi?fct=viewblocked">View Block Log </a></strong>($block_count) </td>
    <td width="118%" height="60" bgcolor="#FFFFFF" class="normaltext">Displays submissions that has been
    rejected. </td>
  </tr>
  <tr>
    <td width="2%" height="60" align="center" bgcolor="#FFFFFF" class="normaltext"><strong><img
    src="$web_url/ic_erase.gif"> </strong></td>
    <td width="10%" height="60" bgcolor="#FFFFFF" class="normaltext"><strong>&nbsp;&nbsp;&nbsp; <a
    href="$admin_url/admin60.cgi?fct=clear">Clear Log History </a></strong></td>
    <td width="118%" height="60" bgcolor="#FFFFFF" class="normaltext">Clears the blocked log database table. </td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
    <td width="99%"></td>
  </tr>
</table>




</body>
</html>

];

}





sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

